import sys
from argparse import ArgumentParser
from PySide6.QtWidgets import QApplication

from htsct.gui.RibbonBuilder import MainWindow as RibbonBuilder
from htsct.gui.YacifEditer import MainWindow as YacifEditer


class CLICommand:
    """gui
    """

    @staticmethod
    def add_argments(parser: ArgumentParser):
        add = parser.add_argument
        add("--yacif", action="store_true", dest="yacif")

    @staticmethod
    def run(args, parser):
        if args.yacif:
            app = QApplication(sys.argv)
            win = YacifEditer()
            win.show()
            sys.exit(app.exec())
        app = QApplication(sys.argv)
        win = RibbonBuilder()
        win.show()
        sys.exit(app.exec())
