from argparse import ArgumentParser
from shutil import copy

from htsct.constants import HTS_HOME
from htsct.utils.resources import files as packageFiles
from toml import load, dump


class CLICommand:
    """初始化配置文件，设置环境变量

    说明：
        1.在$HOME下导出.htsct.toml配置文件
    """

    @staticmethod
    def add_argments(parser: ArgumentParser):
        pass

    @staticmethod
    def run(args, parser):
        copy_statics()
        data = load(HTS_HOME / ".htsct.toml")
        data['vasp']['vasp_std'] = input(f"请输入vasp_std执行路径(默认:{data['vasp']['vasp_std']})\n:") or data['vasp'][
            'vasp_std']
        data['vasp']['vasp_ncl'] = input(f"请输入vasp_ncl执行路径(默认:{data['vasp']['vasp_ncl']})\n:") or data['vasp'][
            'vasp_ncl']
        data['vasp']['vasp_gam'] = input(f"请输入vasp_gam执行路径(默认:{data['vasp']['vasp_gam']})\n:") or data['vasp'][
            'vasp_gam']
        data['scripts']['qsub'] = input(f"请输入qsub脚本路径(默认:{data['scripts']['qsub']})\n:") or data['scripts']['qsub']
        data['output']['task_log'] = input(f"请输入task_log任务日志路径(默认:{data['output']['task_log']})\n:") or data['output'][
            'task_log']
        data['output']['figs_path'] = input(f"请输入figs_path图片保存路径(默认:{data['output']['figs_path']})\n:") or \
                                      data['output']['figs_path']
        data['output']['db_dir'] = input(f"请输入数据库保存路径(默认:{data['output']['db_dir']})\n:") or data['output']['db_dir']
        data['output']['work_path'] = input(f"请输入工作路径路径(默认:{data['output']['work_path']})\n:") or data['output'][
            'work_path']
        data['output']['wait_interval'] = input(f"请输入等待时间间隔(默认:{data['output']['wait_interval']})\n:") or \
                                          data['output']['wait_interval']
        with open(HTS_HOME / ".htsct.toml", "w+", encoding="utf-8") as fd:
            dump(data, fd)


def copy_statics():
    print("Start initialize...")
    HTS_HOME.mkdir(parents=True, exist_ok=True)
    files = packageFiles("htsct.statics").iterdir()
    for file in files:
        try:
            print(f"Copy '{file}' to '{HTS_HOME}'", end=" ... ")
            copy(file, HTS_HOME)
            print("done")
        except Exception as e:
            print(e)
