from io import BytesIO
import yaml
from ase.io.cif import parse_cif_ase


def read(filename):
    with open(filename) as fd:
        cif = yaml.load(fd, Loader=yaml.FullLoader)["cif"]
    with BytesIO() as b1:  # reload structure from cif
        b1.write(bytes(cif, encoding="utf-8"))
        b1.seek(0)
        cif_block = parse_cif_ase(b1)
        return list(cif_block)[0].get_atoms()


if __name__ == '__main__':
    atoms = read(r"E:\Projects\High throughput screen\test\test.yacif")
    print(atoms)
    atoms.edit()
